import { createDynamicScopeExpression } from '../src/dynamic-scope'

test('Usage example', () => {
  function someFuncShouldBeDynamicScope(...args) {
    return [message, ...args].join(' ') + '!'
  }

  const dynamicFuncExpression = createDynamicScopeExpression(someFuncShouldBeDynamicScope)

  // Non-strict mode
  ;(() => {
    const message = 'Hello'
    const func = eval(dynamicFuncExpression)()
    expect(func('World')).toEqual('Hello World!') // Hello World!
  })()

  // Strict mode
  ;(() => {
    'use strict'
    const func = eval(dynamicFuncExpression)({ message: 'Hello' })
    expect(func('World')).toEqual('Hello World!') // Hello World!
  })()
})
